local font_name = "fonts/comic.ttf"

Monitor = Core.class(Sprite)

function Monitor:init(...)
	local names = {...}
	self.textFields = {}
	self.yPos = 0
	if (#names > 0) then
		for _,value in pairs(names) do
			local tf = ShadowText.new(font_name, 30, value..": -")
			self.textFields[value] = tf
			self.yPos = self.yPos + tf:getHeight() + 10
			tf:setY(self.yPos)
			self:addChild(tf)
		end
	end
end
--
function Monitor:setTextColor(name, color)
	self.textFields[name]:setTextColor(color)
end
--
function Monitor:add(name)
	local tf = ShadowText.new(font_name, name..": -")
	self.textFields[name] = tf
	self.yPos = self.yPos + tf:getHeight() + 10
	tf:setY(self.yPos)
	self:addChild(tf)
end
--
function Monitor:remove(name)
	local tf = self.textFields[name]
	self.yPos = self.yPos - tf:getHeight() - 10
	self:removeChild(tf)
	self.textFields[name] = nil
end
--
function Monitor:setText(name, text)
	self.textFields[name]:setText(name..": "..text)
end