local sin,cos,sqrt=math.sin,math.cos,math.sqrt

local function rectVSrect(rect1, rect2)
	local A,B,C,BL,TR = Vec2.new(),Vec2.new(),Vec2.new(),Vec2.new(),Vec2.new()	
	local ang = rect1.rotation - rect2.rotation
	ang  = ^<ang
	local cosa = cos(ang)
	local sina = sin(ang)
	local t,x,a,dx,ext1,ext2
	C = rect2.pos:copy()
	C:sub(rect1.pos)
	C:rotate(rect2:getRotationRad())
	BL = C:copy() TR = C:copy()	
	BL.x -= rect2.size.x / 2 BL.y -= rect2.size.y / 2
	TR.x += rect2.size.x / 2 TR.y += rect2.size.y / 2	
	A.x = -(rect1.size.y / 2) * sina B.x = A.x t = (rect1.size.x / 2) * cosa A.x += t B.x -= t	
	A.y =  (rect1.size.y / 2) * cosa B.y = A.y t = (rect1.size.x / 2) * sina A.y += t B.y -= t	
	t = sina*cosa
	if (t < 0) then t = A.x A.x = B.x B.x = t t = A.y A.y = B.y B.y = t end	
	if (sina < 0) then B.x = -B.x B.y = -B.y end	
	if (B.x > TR.x or B.x > -BL.x) then return false end	
	if (t == 0) then 
		ext1 = A.y ext2 = -ext1
	else
		x = BL.x-A.x a = TR.x-A.x ext1 = A.y
		if (a*x > 0) then
			dx = A.x;
			if (x < 0) then dx -= B.x ext1 -= B.y x = a else dx += B.x ext1 += B.y end
			ext1 *= x ext1 /= dx ext1 += A.y
		end
		x = BL.x+A.x a = TR.x+A.x
		ext2 = -A.y
		if (a*x > 0) then
			dx = -A.x
			if (x < 0) then dx -= B.x ext2 -= B.y x = a else dx += B.x ext2 += B.y end
			ext2 *= x ext2 /= dx ext2 -= A.y
		end
	end	
	return not((ext1 < BL.y and ext2 < BL.y) or (ext1 > TR.y and ext2 > TR.y))
end

local function rectVScircle(rect, circle)
	local ang = ^<rect:getRotation()
	local cosa = cos(ang)
	local sina = sin(ang)
	
	local C = circle.pos:copy()
	C:rotateAround(-ang, rect.pos)
	
	local rectX = rect.pos.x - rect.size.x / 2
	local rectY = rect.pos.y - rect.size.y / 2
	
	local closest = Vec2.new(
		(C.x < rectX and rectX or (C.x > rectX + rect.size.x and rectX + rect.size.x or C.x)),
		(C.y < rectY and rectY or (C.y > rectY + rect.size.y and rectY + rect.size.y or C.y))
	)
	
	return C:dist2(closest) < circle:getRadius() ^ 2
end

local function circleVScircle(circle1, circle2)
	return circle1.pos:dist2(circle2.pos) <= (circle1.r + circle2.r) ^ 2
end
--
local function checkCollision(obj1, obj2)
	if (obj1.size and obj2.r) then
		return rectVScircle(obj1, obj2)
	elseif (obj2.size and obj1.r) then
		return rectVScircle(obj2, obj1)
	elseif (obj1.r and obj2.r) then
		return circleVScircle(obj1, obj2)
	elseif (obj1.size and obj2.size) then
		return rectVSrect(obj1, obj2)
	end
	return false	
end
--

SCD = Core.class()

function SCD:init(cellsize)
	self.sh = Spatialhash.new(cellsize)
end

function SCD:add(shape)
	local v = shape:getAABB()
	self.sh:insert(shape, v[1],v[2],v[5],v[6])
end
function SCD:remove(shape)
	local v = shape:getAABB()
	self.sh:remove(shape, v[1],v[2],v[5],v[6])	
end
function SCD:update(shape, newX, newY)
	local old = shape:getAABB()
	shape:setPosition(newX, newY)
	local new = shape:getAABB()
	self.sh:update(shape, old[1],old[2],old[5],old[6], new[1],new[2],new[5],new[6])
end
function SCD:check(shape)
	local aabb = shape:getAABB()
	local range = self.sh:inRange(aabb[1],aabb[2],aabb[5],aabb[6])
	
	local list = {}
	for _,v in pairs(range) do
		if (shape ~= v and checkCollision(v, shape)) then
			rawset(list, #list + 1, v)
		end
	end
	return list
end