local acos,sin,cos,sqrt,abs=math.acos,math.sin,math.cos,math.sqrt,math.abs

Vec2 = Core.class()

function Vec2:init(x, y) self.x = x or 0 self.y = y or 0 end
function Vec2:set(x, y) self.x = x or 0 self.y = y or 0 end
function Vec2:copy() return Vec2.new(self.x, self.y) end
function Vec2:add(other) self.x += other.x self.y += other.y end
function Vec2:sub(other) self.x -= other.x self.y -= other.y end
function Vec2:rotate(angle) local t, cosa, sina = self.x, cos(angle), sin(angle) self.x =  t * cosa + self.y * sina self.y = -t * sina + self.y * cosa end
function Vec2:rotateAround(angle, point) local t,cosa,sina = self.x,cos(angle),sin(angle) self.x = cosa * ( t - point.x ) - sina * ( self.y - point.y ) + point.x self.y = sina * ( t - point.x ) + cosa * ( self.y - point.y ) + point.y end
function Vec2:dist(other) local dx = abs(self.x - other.x) local dy = abs(self.y - other.y) return sqrt((dx*dx)+(dy*dy)) end
function Vec2:dist2(other) local dx = abs(self.x - other.x) local dy = abs(self.y - other.y) return ((dx*dx)+(dy*dy)) end
function Vec2:dot(other) return self.x * other.x + self.y * other.y end
function Vec2:angle(other) return ^>math.atan2(other.y - self.y, other.x - self.x) end
function Vec2:angle2(x, y) return ^>math.atan2(y - self.y, x - self.x) end
function Vec2:unpack() return self.x, self.y end