ShadowText = Core.class(Sprite)

function ShadowText:init(fontName, fontSize, text)
	self.fontName = fontName
	self.fontSize = fontSize or 12
	self.font = TTFont.new(self.fontName, self.fontSize, true)
	
	self.shadow = TextField.new(self.font, text)
	self.shadow:setPosition(2, 2)
	self.shadow:setTextColor(0x22712a)
	self:addChild(self.shadow)
	
	self.tf = TextField.new(self.font, text)
	self.tf:setTextColor(0xffffff)
	self:addChild(self.tf)
	
	self.offset = 2
	self.angle = 45
	self:setShadowAngle(self.angle)
end
--
function ShadowText:setFontSize(fontSize)
	if (self.font) then
		self:setFont(self.fontName, fontSize)
	end
end
--
function ShadowText:setFont(fontName, fontSize)
	self.fontName = fontName
	self.fontSize = fontSize or 12
	self.font = TTFont.new(self.fontName, self.fontSize)
	self.shadow:setFont(self.font)
	self.tf:setFont(self.font)
end
--
function ShadowText:setText(text)
	self.tf:setText(text)
	self.shadow:setText(text)
end
--
function ShadowText:setTextColor(color)
	self.tf:setTextColor(color)
end
--
function ShadowText:setShadowAngle(angle)
	self.angle = angle
	local dx = math.cos(math.rad(angle)) * self.offset
	local dy = math.sin(math.rad(angle)) * self.offset
	self.shadow:setPosition(dx, dy)
end
--
function ShadowText:setShadowOffset(offset)
	self.offset = offset
	local dx = math.cos(math.rad(self.angle)) * self.offset
	local dy = math.sin(math.rad(self.angle)) * self.offset
	self.shadow:setPosition(dx, dy)
end
--
function ShadowText:setShadowColor(color)
	self.shadow:setTextColor(color)
end
--
function ShadowText:setShadowParams(params)
	params.angle = params.angle or 45
	params.offset = params.offset or 2
	params.color = params.color or 0x000000
	
	local dx = math.cos(math.rad(params.angle)) * params.offset
	local dy = math.sin(math.rad(params.angle)) * params.offset
	self.shadow:setTextColor(params.color)
	self.shadow:setPosition(dx, dy)
end