--[[
M - MoveTo, 2 values (x,y)
L - LineTo, 2 values (x,y)
Q - QuadTo, 4 values (c0x,c0y,x,y)
C - CubicTo, 6 values (c0x,c0y,c1x,c1y,x,y)
H - Horzontal Line, 1 value (x)
V - Vertical Line, 1 value (y)
A - ArcTo, 7 values (r1,r2,angle,largeArc,sweep,x,y)
Z - Close, no parameter
* - repeat last command until all coordinates are exhausted
]]

function CreateRect(w, h, ax, ay)
	h = h or w
	local p=Path2D.new()
	local ms="MHVHVZ"
	local mp={0,0, w, h, 0, 0}
	p:setFillColor(0, 1)
	p:setLineColor(0xffffff,1)
	p:setPath(ms,mp)
	if (ax and ay) then p:setAnchorPosition(w*ax,h*ay) end
	return p
end

function CreateCircle(r)
	local p=Path2D.new()
	local ms="MAAZ"
	local mp={-r,0, r,r,0,0,0,r,0, r,r,0,0,0,-r,0}
	p:setPath(ms,mp)
	p:setFillColor(0, 1)
	p:setLineColor(0xffffff,1)
	return p
end

function CreatePoly(points)
	local ms="M"
	for i = 2, #points/2 do 
		ms = ms .. "L"
	end
	ms = ms .. "Z"
	local p=Path2D.new()
	p:setPath(ms,points)
	p:setLineThickness(2)
	p:setLineColor(RED,1)
	return p
end